package alcotest

  1. Overview
  2. Docs
Alcotest is a lightweight and colourful test framework

Install

Authors

Maintainers

Sources

alcotest-1.7.0.tbz
sha256=812bacdb34b45e88995e07d7306bdab2f72479ef1996637f1d5d1f41667902df
sha512=4ae1ba318949ec9db8b87bc8072632a02f0e4003a95ab21e474f5c34c3b5bde867b0194a2d0ea7d9fc4580c70a30ca39287d33a8c134acc7611902f79c7b7ce8

Description

Alcotest exposes simple interface to perform unit tests. It exposes a simple TESTABLE module type, a check function to assert test predicates and a run function to perform a list of unit -> unit test callbacks.

Alcotest provides a quiet and colorful output where only faulty runs are fully displayed at the end of the run (with the full logs ready to inspect), with a simple (yet expressive) query language to select the tests to run.

Published: 27 Feb 2023

README

README.md

A lightweight and colourful test framework.


Alcotest exposes a simple interface to perform unit tests. It exposes a simple TESTABLE module type, a check function to assert test predicates and a run function to perform a list of unit -> unit test callbacks.

Alcotest provides a quiet and colorful output where only faulty runs are fully displayed at the end of the run (with the full logs ready to inspect), with a simple (yet expressive) query language to select the tests to run. See the manpage for details.

The API documentation can be found here. For information on contributing to Alcotest, see CONTRIBUTING.md.


Examples

A simple example (taken from examples/simple.ml):

Generated by the following test suite specification:

(* Build with `ocamlbuild -pkg alcotest simple.byte` *)

(* A module with functions to test *)
module To_test = struct
  let lowercase = String.lowercase_ascii
  let capitalize = String.capitalize_ascii
  let str_concat = String.concat ""
  let list_concat = List.append
end

(* The tests *)
let test_lowercase () =
  Alcotest.(check string) "same string" "hello!" (To_test.lowercase "hELLO!")

let test_capitalize () =
  Alcotest.(check string) "same string" "World." (To_test.capitalize "world.")

let test_str_concat () =
  Alcotest.(check string) "same string" "foobar" (To_test.str_concat ["foo"; "bar"])

let test_list_concat () =
  Alcotest.(check (list int)) "same lists" [1; 2; 3] (To_test.list_concat [1] [2; 3])

(* Run it *)
let () =
  let open Alcotest in
  run "Utils" [
      "string-case", [
          test_case "Lower case"     `Quick test_lowercase;
          test_case "Capitalization" `Quick test_capitalize;
        ];
      "string-concat", [ test_case "String mashing" `Quick test_str_concat  ];
      "list-concat",   [ test_case "List mashing"   `Slow  test_list_concat ];
    ]

The result is a self-contained binary which displays the test results. Use dune exec examples/simple.exe -- --help to see the runtime options.

Here's an example of a of failing test suite:

By default, only the first failing test log is printed to the console (and all test logs are captured on disk). Pass --show-errors to print all error messages.

Using Alcotest with opam and Dune

Add (alcotest :with-test) to the depends stanza of your dune-project file, or "alcotest" {with-test} to your opam file. Use the with-test package variable to declare your tests opam dependencies. Call opam to install them:

$ opam install --deps-only --with-test .

You can then declare your test and link with Alcotest: (test (libraries alcotest …) …), and run your tests:

$ dune runtest

Selecting tests to execute

You can filter which tests to run by supplying a regular expression matching the names of the tests to execute, or by passing a regular expression and a comma-separated list of test numbers (or ranges of test numbers, e.g. 2,4..9):

$ ./simple.native test '.*concat*'
Testing Utils.
[SKIP]     string-case            0   Lower case.
[SKIP]     string-case            1   Capitalization.
[OK]       string-concat          0   String mashing.
[OK]       list-concat            0   List mashing.
The full test results are available in `_build/_tests`.
Test Successful in 0.000s. 2 tests run.

$ ./simple.native test 'string-case' '1..3'
Testing Utils.
[SKIP]     string-case            0   Lower case.
[OK]       string-case            1   Capitalization.
[SKIP]     string-concat          0   String mashing.
[SKIP]     list-concat            0   List mashing.
The full test results are available in `_build/_tests`.
Test Successful in 0.000s. 1 test run.

Note that you cannot filter by test case name (i.e. Lower case or Capitalization), you must filter by test name & number instead.

See the examples directory for more examples.

Quick and Slow tests

In general you should use `Quick tests: tests that are ran on any invocations of the test suite. You should only use `Slow tests for stress tests that are ran only on occasion (typically before a release or after a major change). These slow tests can be suppressed by passing the -q flag on the command line, e.g.:

$ ./test.exe -q # run only the quick tests
$ ./test.exe    # run quick and slow tests

Passing custom options to the tests

In most cases, the base tests are unit -> unit functions. However, it is also possible to pass an extra option to all the test functions by using 'a -> unit, where 'a is the type of the extra parameter.

In order to do this, you need to specify how this extra parameter is read on the command-line, by providing a Cmdliner term for command-line arguments which explains how to parse and serialize values of type 'a (note: do not use positional arguments, only optional arguments are supported).

For instance:

let test_nice i = Alcotest.(check int) "Is it a nice integer?" i 42

let int =
  let doc = "What is your preferred number?" in
  Cmdliner.Arg.(required & opt (some int) None & info ["n"] ~doc ~docv:"NUM")

let () =
  Alcotest.run_with_args "foo" int [
    "all", ["nice", `Quick, test_nice]
  ]

Will generate test.exe such that:

$ test.exe test
test.exe: required option -n is missing

$ test.exe test -n 42
Testing foo.
[OK]                all          0   int.

Lwt

Alcotest provides an Alcotest_lwt module that you could use to wrap Lwt test cases. The basic idea is that instead of providing a test function in the form unit -> unit, you provide one with the type unit -> unit Lwt.t and alcotest-lwt calls Lwt_main.run for you.

However, there are a couple of extra features:

  • If an async exception occurs, it will cancel your test case for you and fail it (rather than exiting the process).

  • You get given a switch, which will be turned off when the test case finishes (or fails). You can use that to free up any resources.

For instance:

let free () = print_endline "freeing all resources"; Lwt.return ()

let test_lwt switch () =
  Lwt_switch.add_hook (Some switch) free;
  Lwt.async (fun () -> failwith "All is broken");
  Lwt_unix.sleep 10.

let () =
  Lwt_main.run @@ Alcotest_lwt.run "foo" [
    "all", [
      Alcotest_lwt.test_case "one" `Quick test_lwt
    ]
  ]

Will generate:

$ test.exe
Testing foo.
[ERROR]             all          0   one.
-- all.000 [one.] Failed --
in _build/_tests/all.000.output:
freeing all resources
[failure] All is broken

Comparison with other testing frameworks

The README is pretty clear about that:

Alcotest is the only testing framework using colors!

More seriously, Alcotest is similar to ounit but it fixes a few of the problems found in that library:

  • Alcotest has a nicer output, it is easier to see what failed and what succeeded and to read the log outputs of the failed tests;

  • Alcotest uses combinators to define pretty-printers and comparators between the things to test.

Other nice tools doing different kind of testing also exist:

  • qcheck does random generation and property testing (e.g. Quick Check);

  • crowbar and bun are similar to qcheck, but use compiler-directed randomness, i.e. they take advantage of the AFL support the OCaml compiler;

  • ppx_inline_tests allows to write tests in the same file as your source-code; they will be run only in a special mode of compilation.

Dependencies (9)

  1. ocaml-syntax-shims
  2. uutf >= "1.0.1"
  3. stdlib-shims
  4. re >= "1.7.2"
  5. cmdliner >= "1.1.0"
  6. astring
  7. fmt >= "0.8.7"
  8. ocaml >= "4.05.0"
  9. dune >= "3.0"

Dev Dependencies (1)

  1. odoc with-doc

  1. ahrocksdb
  2. albatross >= "1.5.0"
  3. alcotest-async < "1.0.0" | >= "1.7.0"
  4. alcotest-js >= "1.7.0"
  5. alcotest-lwt < "1.0.0" | >= "1.7.0"
  6. alcotest-mirage >= "1.7.0"
  7. alg_structs_qcheck
  8. algaeff
  9. ambient-context
  10. ambient-context-eio
  11. ambient-context-lwt
  12. angstrom >= "0.7.0"
  13. ansi >= "0.6.0"
  14. anycache >= "0.7.4"
  15. anycache-async
  16. anycache-lwt
  17. archetype >= "1.4.2"
  18. archi
  19. arp != "2.3.1"
  20. arp-mirage < "2.0.0"
  21. arrakis
  22. art
  23. asai
  24. asak >= "0.2"
  25. asli >= "0.2.0"
  26. asn1-combinators >= "0.2.2"
  27. atd >= "2.3.3"
  28. atdgen >= "2.10.0"
  29. atdpy
  30. atdts
  31. backoff
  32. base32
  33. base64 >= "2.1.2" & < "3.2.0" | >= "3.4.0"
  34. bastet
  35. bastet_lwt
  36. bech32
  37. bechamel >= "0.5.0"
  38. bigarray-overlap
  39. bigstringaf
  40. bitlib
  41. blake2
  42. bloomf
  43. bls12-381 < "0.4.1" | >= "3.0.0" & < "18.0"
  44. bls12-381-hash
  45. bls12-381-js >= "0.4.2"
  46. bls12-381-js-gen >= "0.4.2"
  47. bls12-381-legacy
  48. bls12-381-signature
  49. bls12-381-unix
  50. blurhash
  51. builder-web
  52. bulletml
  53. bytebuffer
  54. ca-certs
  55. ca-certs-nss
  56. cactus
  57. caldav
  58. calendar >= "3.0.0"
  59. callipyge
  60. camlix
  61. capnp-rpc
  62. capnp-rpc-lwt < "0.3"
  63. capnp-rpc-mirage >= "0.9.0"
  64. capnp-rpc-unix >= "0.9.0"
  65. caqti >= "1.7.0"
  66. caqti-async >= "1.7.0"
  67. caqti-driver-mariadb >= "1.7.0"
  68. caqti-driver-postgresql >= "1.7.0"
  69. caqti-driver-sqlite3 >= "1.7.0"
  70. caqti-dynload >= "2.0.1"
  71. caqti-eio
  72. caqti-lwt >= "1.7.0"
  73. carray
  74. carton
  75. carton-git
  76. carton-lwt >= "0.4.1"
  77. catala >= "0.6.0"
  78. cborl
  79. ccss >= "1.6"
  80. cf-lwt
  81. chacha
  82. chamelon
  83. chamelon-unix
  84. channel
  85. charrua-client
  86. charrua-client-lwt
  87. charrua-client-mirage < "0.11.0"
  88. charrua-server >= "1.4.1"
  89. checkseum >= "0.0.3"
  90. cid
  91. clarity-lang
  92. class_group_vdf
  93. cohttp >= "0.17.0"
  94. cohttp-curl-async
  95. cohttp-curl-lwt
  96. colombe >= "0.2.0"
  97. color
  98. commons
  99. conan
  100. conan-cli
  101. conan-database
  102. conan-lwt
  103. conan-unix
  104. conduit = "3.0.0"
  105. conex < "0.10.0"
  106. conex-mirage-crypto
  107. conex-nocrypto
  108. conformist
  109. cookie
  110. cow >= "2.2.0"
  111. css
  112. css-parser
  113. cstruct >= "3.3.0"
  114. cstruct-sexp
  115. ctypes-zarith
  116. cuid
  117. curly
  118. current >= "0.4"
  119. current-albatross-deployer
  120. current_git >= "0.6.4"
  121. current_incr
  122. cwe_checker
  123. data-encoding
  124. datakit >= "0.12.0"
  125. datakit-bridge-github >= "0.12.0"
  126. datakit-ci
  127. datakit-client-git >= "0.12.0"
  128. dates_calc
  129. decimal >= "0.3.0"
  130. decompress >= "0.8"
  131. depyt
  132. digestif >= "0.8.1"
  133. dirsp-exchange-kbb2017
  134. dirsp-proscript-mirage
  135. dirsp-ps2ocaml
  136. dispatch >= "0.4.1"
  137. dkim
  138. dkim-bin
  139. dkim-mirage
  140. dkml-dune-dsl-show
  141. dkml-install
  142. dkml-install-installer
  143. dkml-install-runner
  144. dkml-package-console
  145. dns >= "4.0.0"
  146. dns-cli
  147. dns-client >= "4.6.0"
  148. dns-forward < "0.9.0"
  149. dns-forward-lwt-unix
  150. dns-resolver
  151. dns-server
  152. dns-tsig
  153. dnssd
  154. dnssec
  155. dog < "0.2.1"
  156. domain-local-await >= "0.2.1"
  157. domain-local-timeout
  158. domain-name
  159. dream
  160. dream-htmx
  161. dream-pure
  162. dscheck >= "0.1.1"
  163. duff
  164. dune-release >= "1.0.0"
  165. duration >= "0.1.1"
  166. eio < "0.12"
  167. eio_linux
  168. eio_windows
  169. emile
  170. encore
  171. eqaf >= "0.5"
  172. equinoxe
  173. equinoxe-cohttp
  174. equinoxe-hlc
  175. eris
  176. eris-lwt
  177. ezgzip
  178. ezjsonm >= "0.4.2"
  179. ezjsonm-lwt
  180. FPauth
  181. FPauth-core
  182. FPauth-responses
  183. FPauth-strategies
  184. faraday != "0.2.0"
  185. farfadet
  186. fat-filesystem >= "0.12.0"
  187. ff
  188. ff-pbt
  189. flex-array
  190. fsevents-lwt
  191. functoria >= "2.2.0"
  192. functoria-runtime >= "2.2.0" & < "3.0.1" | = "3.1.2"
  193. geojson
  194. geoml >= "0.1.1"
  195. git = "1.4.10" | = "1.5.0" | >= "1.5.2" & != "1.10.0"
  196. git-cohttp
  197. git-cohttp-mirage
  198. git-cohttp-unix
  199. git-mirage
  200. git-unix >= "1.10.0" & != "2.1.0"
  201. gitlab-unix
  202. glicko2
  203. gmap >= "0.3.0"
  204. gobba
  205. graphql
  206. graphql-async
  207. graphql-cohttp >= "0.13.0"
  208. graphql-lwt
  209. graphql_parser != "0.11.0"
  210. graphql_ppx >= "0.7.1"
  211. h1_parser
  212. h2
  213. hacl
  214. hacl-star >= "0.6.0"
  215. hacl_func
  216. hacl_x25519 >= "0.2.0"
  217. highlexer
  218. hkdf
  219. hockmd
  220. http
  221. http-multipart-formdata < "2.0.0"
  222. httpaf >= "0.2.0"
  223. hvsock
  224. icalendar >= "0.1.4"
  225. imagelib >= "20200929"
  226. index
  227. inferno >= "20220603"
  228. influxdb-async
  229. influxdb-lwt
  230. inquire < "0.2.0"
  231. interval-map
  232. iomux
  233. irmin < "0.8.0" | >= "0.9.6" & != "0.11.1" & < "1.0.0" | >= "2.0.0" & != "2.3.0"
  234. irmin-bench >= "2.7.0"
  235. irmin-chunk < "1.3.0" | >= "2.3.0"
  236. irmin-cli
  237. irmin-containers
  238. irmin-fs < "1.3.0" | >= "2.3.0"
  239. irmin-git < "2.0.0" | >= "2.3.0"
  240. irmin-graphql >= "2.3.0"
  241. irmin-http < "2.0.0"
  242. irmin-mem < "1.3.0" | >= "2.3.0"
  243. irmin-pack >= "2.4.0" & != "2.6.1"
  244. irmin-pack-tools
  245. irmin-test >= "2.2.0" & < "3.4.0" | >= "3.9.0"
  246. irmin-tezos
  247. irmin-tezos-utils
  248. irmin-unix >= "1.0.0" & < "1.3.3" | >= "2.4.0" & != "2.6.1"
  249. irmin-watcher != "0.3.0"
  250. jekyll-format
  251. jerboa
  252. jitsu
  253. jose
  254. json-data-encoding >= "0.9"
  255. json_decoder
  256. jsonxt
  257. junit_alcotest
  258. jwto
  259. kcas >= "0.6.0"
  260. kcas_data >= "0.6.0"
  261. ke >= "0.2"
  262. kkmarkdown
  263. kmt
  264. lambda-runtime
  265. lambda_streams
  266. lambda_streams_async
  267. lambdapi >= "2.0.0"
  268. lambdoc >= "1.0-beta4"
  269. ledgerwallet-tezos >= "0.2.1"
  270. letters
  271. lmdb >= "1.0"
  272. lockfree >= "0.3.0"
  273. logical
  274. logtk >= "1.6"
  275. lp
  276. lp-glpk
  277. lp-glpk-js
  278. lp-gurobi
  279. lru
  280. lt-code
  281. luv
  282. mbr-format >= "1.0.0"
  283. mdx >= "1.6.0"
  284. mec
  285. mechaml = "1.0.0" | >= "1.2.1"
  286. merge-queues >= "0.2.0"
  287. merge-ropes >= "0.2.0"
  288. metrics
  289. mimic
  290. minicaml = "0.3.1" | >= "0.4"
  291. mirage >= "4.0.0~beta1"
  292. mirage-block-partition
  293. mirage-block-ramdisk = "0.3"
  294. mirage-channel >= "4.0.0"
  295. mirage-channel-lwt < "3.1.0"
  296. mirage-crypto-ec != "0.9.2"
  297. mirage-flow >= "1.0.2" & < "1.2.0"
  298. mirage-flow-unix != "1.3.0" & < "1.5.0" | = "2.0.0" | >= "3.0.0"
  299. mirage-fs-mem
  300. mirage-fs-unix >= "1.2.0" & < "1.4.1"
  301. mirage-kv >= "2.0.0"
  302. mirage-kv-mem
  303. mirage-logs >= "0.3.0"
  304. mirage-nat
  305. mirage-net-unix >= "2.3.0"
  306. mirage-runtime >= "4.0.0~beta1"
  307. mirage-tc
  308. mirage-vnetif-stack
  309. mjson
  310. mmdb < "0.3.0"
  311. mnd
  312. monocypher
  313. mrmime >= "0.2.0"
  314. mrt-format
  315. msgpck >= "1.6"
  316. mssql >= "2.0.3"
  317. multibase
  318. multicore-magic >= "1.0.1"
  319. multihash
  320. multihash-digestif
  321. multipart-form-data
  322. multipart_form
  323. multipart_form-lwt
  324. named-pipe
  325. nanoid
  326. nbd >= "4.0.3"
  327. nbd-tool
  328. nloge
  329. nocoiner
  330. non_empty_list
  331. OCADml >= "0.6.0"
  332. ocaml-r >= "0.4.0"
  333. ocaml-version >= "3.1.0"
  334. ocamlformat >= "0.13.0" & != "0.19.0~4.13preview" & < "0.25.1"
  335. ocamlformat-lib
  336. ocamlformat-rpc < "removed"
  337. ocamline
  338. ocluster
  339. octez-bls12-381-hash
  340. octez-bls12-381-signature
  341. octez-libs
  342. octez-mec
  343. odoc >= "1.4.0" & < "2.1.0"
  344. oidc
  345. opam-0install
  346. opam-compiler
  347. opam-file-format >= "2.1.1"
  348. opentelemetry >= "0.6"
  349. opentelemetry-client-cohttp-lwt >= "0.6"
  350. opentelemetry-client-ocurl >= "0.6"
  351. opentelemetry-cohttp-lwt >= "0.6"
  352. opentelemetry-lwt >= "0.6"
  353. opium >= "0.15.0"
  354. opium-graphql
  355. opium-testing
  356. opium_kernel
  357. orewa
  358. orgeat
  359. ortac-core
  360. osnap < "0.3.0"
  361. osx-acl
  362. osx-attr
  363. osx-cf
  364. osx-fsevents
  365. osx-membership
  366. osx-mount
  367. osx-xattr
  368. otoggl
  369. owl >= "0.6.0" & != "0.9.0" & != "1.0.0"
  370. owl-base < "0.5.0"
  371. owl-ode >= "0.1.0" & != "0.2.0"
  372. owl-symbolic
  373. par_incr
  374. passmaker
  375. patch
  376. pbkdf
  377. pecu >= "0.2"
  378. pf-qubes
  379. pg_query >= "0.9.6"
  380. pgx >= "1.0"
  381. pgx_unix >= "1.0"
  382. pgx_value_core
  383. pgx_value_ptime
  384. phylogenetics
  385. piaf
  386. piece_rope
  387. plebeia >= "2.0.0"
  388. polyglot
  389. polynomial
  390. ppx_blob >= "0.3.0"
  391. ppx_catch
  392. ppx_deriving_cmdliner
  393. ppx_deriving_qcheck
  394. ppx_deriving_rpc
  395. ppx_deriving_yaml
  396. ppx_graphql >= "0.2.0"
  397. ppx_inline_alcotest
  398. ppx_map
  399. ppx_parser
  400. ppx_protocol_conv >= "5.0.0"
  401. ppx_protocol_conv_json >= "5.0.0"
  402. ppx_protocol_conv_jsonm >= "5.0.0"
  403. ppx_protocol_conv_msgpack >= "5.0.0"
  404. ppx_protocol_conv_xml_light >= "5.0.0"
  405. ppx_protocol_conv_xmlm
  406. ppx_protocol_conv_yaml >= "5.0.0"
  407. ppx_repr
  408. ppx_subliner
  409. ppx_units
  410. ppx_yojson >= "1.1.0"
  411. pratter
  412. prbnmcn-ucb1 >= "0.0.2"
  413. prc
  414. preface
  415. pretty_expressive
  416. prettym
  417. proc-smaps
  418. producer
  419. progress
  420. prom
  421. prometheus < "1.2"
  422. prometheus-app
  423. protocell
  424. protocol-9p >= "0.3" & < "0.11.0" | >= "0.11.2"
  425. protocol-9p-unix
  426. psq
  427. pyast
  428. qcheck >= "0.18"
  429. qcheck-alcotest
  430. qcheck-core >= "0.18"
  431. radis
  432. randii
  433. reason-standard
  434. reparse >= "2.0.0" & < "3.0.0"
  435. reparse-unix < "2.1.0"
  436. resp
  437. resp-unix >= "0.10.0"
  438. resto >= "0.9"
  439. rfc1951 < "1.0.0"
  440. routes < "2.0.0"
  441. rpc >= "7.1.0"
  442. rpclib >= "7.1.0"
  443. rpclib-async
  444. rpclib-lwt >= "7.1.0"
  445. rubytt
  446. SZXX >= "4.0.0"
  447. salsa20
  448. salsa20-core
  449. sanddb >= "0.2"
  450. saturn < "0.4.1"
  451. saturn_lockfree < "0.4.1"
  452. scaml >= "1.5.0"
  453. scrypt-kdf
  454. secp256k1 >= "0.4.1"
  455. secp256k1-internal
  456. semver >= "0.2.1"
  457. sendmail
  458. sendmail-lwt
  459. sendmsg
  460. seqes
  461. session-cookie
  462. session-cookie-async
  463. session-cookie-lwt
  464. sihl < "0.2.0"
  465. sihl-type
  466. slug
  467. smol
  468. smol-helpers
  469. sodium-fmt
  470. solidity-alcotest
  471. spdx_licenses
  472. spectrum >= "0.2.0"
  473. spin >= "0.7.0"
  474. squirrel
  475. ssh-agent
  476. ssl >= "0.6.0"
  477. stramon-lib
  478. syslog-rfc5424
  479. tar-mirage >= "2.4.0"
  480. tcpip >= "2.4.2" & < "3.4.2" | >= "6.2.0"
  481. tdigest < "2.1.0"
  482. terminal
  483. terminal_size >= "0.1.1"
  484. terminus
  485. terminus-cohttp
  486. terminus-hlc
  487. textmate-language >= "0.3.0"
  488. textrazor
  489. tezos-base-test-helpers < "17.1"
  490. tezos-bls12-381-polynomial
  491. tezos-client-base < "17.1"
  492. tezos-client-base-unix >= "13.0" & < "17.1"
  493. tezos-crypto >= "8.0" & < "9.0" | >= "11.0" & < "12.0" | >= "13.0" & < "17.1"
  494. tezos-crypto-dal < "17.1"
  495. tezos-error-monad >= "12.0" & < "17.1"
  496. tezos-event-logging-test-helpers < "17.1"
  497. tezos-lmdb
  498. tezos-micheline = "13.0"
  499. tezos-plompiler = "0.1.3"
  500. tezos-plonk = "0.1.3"
  501. tezos-shell-services >= "13.0" & < "17.1"
  502. tezos-signer-backends >= "8.0" & < "13.0"
  503. tezos-stdlib >= "8.0" & < "12.0" | >= "13.0" & < "17.1"
  504. tezos-test-helpers < "17.1"
  505. tezos-version >= "13.0" & < "17.1"
  506. tezos-webassembly-interpreter < "17.1"
  507. tftp
  508. thread-table
  509. timedesc
  510. timere
  511. timmy
  512. timmy-jsoo
  513. timmy-unix
  514. tls >= "0.12.0"
  515. toc
  516. topojson
  517. topojsone
  518. traits
  519. transept
  520. twostep
  521. typebeat
  522. tyre >= "0.4"
  523. tyxml >= "4.0.0"
  524. tyxml-jsx
  525. tyxml-ppx >= "4.3.0"
  526. tyxml-syntax
  527. uecc
  528. ulid
  529. unix-dirent
  530. unix-errno >= "0.3.0"
  531. unix-fcntl >= "0.3.0"
  532. unix-sys-resource
  533. unix-sys-stat
  534. unix-time
  535. unstrctrd
  536. uring < "0.4"
  537. user-agent-parser
  538. uspf
  539. uspf-lwt
  540. uspf-unix
  541. utop >= "2.13.0"
  542. validator
  543. vercel
  544. vpnkit
  545. wayland >= "2.0"
  546. websocketaf
  547. x509 >= "0.7.0"
  548. xapi-rrd >= "1.8.2"
  549. xapi-stdext-date
  550. xapi-stdext-encodings
  551. xapi-stdext-std >= "4.16.0"
  552. yaml
  553. yaml-sexp
  554. yocaml
  555. yocaml_yaml
  556. yojson >= "1.6.0"
  557. yuscii >= "0.3.0"
  558. yuujinchou >= "1.0.0"
  559. zar
  560. zed >= "3.2.2"
  561. zlist < "0.4.0"

Conflicts (1)

  1. result < "1.5"